%define anolis_release 1

%define project github.com/NVIDIA/nvidia-container-toolkit
%define debug_package %{nil}
Name:           nvidia-container-toolkit
Version:        1.17.3
Release:        %{anolis_release}%{?dist}
Summary:        NVIDIA Container Toolkit

License:        Apache-2.0 
URL:            https://github.com/NVIDIA/nvidia-container-toolkit
Source0:        https://github.com/NVIDIA/nvidia-container-toolkit/archive/refs/tags/v%{version}.tar.gz#/nvidia-container-toolkit-%{version}.tar.gz

BuildRequires:  golang
BuildRequires:  golang-github-cpuguy83-md2man 
Requires:       libnvidia-container-tools
Requires:       nvidia-container-toolkit-base = %{version}-%{release}
Requires:       libseccomp
Provides:       nvidia-container-runtime = %{version}
Provides:       nvidia-container-runtime
Provides:       nvidia-container-runtime-hook
ExclusiveArch:  x86_64 aarch64

%description
Provides tools and utilities to enable GPU support in containers.

%package base
Summary: NVIDIA Container Toolkit Base
Provides: nvidia-container-runtime

%description base
Provides tools such as the NVIDIA Container Runtime and NVIDIA Container Toolkit CLI to enable GPU support in containers.


%package operator-extensions
Summary: NVIDIA Container Toolkit Operator Extensions
Requires: nvidia-container-toolkit-base == %{version}-%{release}

%description operator-extensions
Provides tools for using the NVIDIA Container Toolkit with the GPU Operator


%prep
%autosetup


%build
export GOPATH=$HOME/go
mkdir -pv $HOME/go/src/%{project}
rm -rf $HOME/go/src/%{project}/*
cp -avr * $HOME/go/src/%{project}
cd $HOME/go/src/%{project}

go build -v -ldflags "-s -w" \
    -o bin/nvidia-ctk \
    ./cmd/nvidia-ctk

go build -v -ldflags "-s -w" \
    -o bin/nvidia-container-runtime-hook \
    ./cmd/nvidia-container-runtime-hook

go build -v -ldflags "-s -w" \
    -o bin/nvidia-container-runtime \
    ./cmd/nvidia-container-runtime

go build -v -ldflags "-s -w" \
    -o bin/nvidia-container-runtime.cdi \
    ./cmd/nvidia-container-runtime.cdi

go build -v -ldflags "-s -w" \
    -o bin/nvidia-container-runtime.legacy \
    ./cmd/nvidia-container-runtime.legacy

go build -v -ldflags "-s -w" \
    -o bin/nvidia-cdi-hook \
    ./cmd/nvidia-cdi-hook

%install
install -D -m 0755 $HOME/go/src/%{project}/bin/nvidia-ctk %{buildroot}/%{_bindir}/nvidia-ctk
install -D -m 0755 $HOME/go/src/%{project}/bin/nvidia-container-runtime-hook %{buildroot}/%{_bindir}/nvidia-container-runtime-hook
install -D -m 0755 $HOME/go/src/%{project}/bin/nvidia-container-runtime %{buildroot}/%{_bindir}/nvidia-container-runtime
install -D -m 0755 $HOME/go/src/%{project}/bin/nvidia-container-runtime.cdi %{buildroot}/%{_bindir}/nvidia-container-runtime.cdi
install -D -m 0755 $HOME/go/src/%{project}/bin/nvidia-container-runtime.legacy %{buildroot}/%{_bindir}/nvidia-container-runtime.legacy
install -D -m 0755 $HOME/go/src/%{project}/bin/nvidia-cdi-hook %{buildroot}/%{_bindir}/nvidia-cdi-hook


%post
mkdir -p %{_localstatedir}/lib/rpm-state/nvidia-container-toolkit
cp -af %{_bindir}/nvidia-container-runtime-hook %{_localstatedir}/lib/rpm-state/nvidia-container-toolkit

%posttrans
if [ ! -e %{_bindir}/nvidia-container-runtime-hook ]; then
  cp -avf %{_localstatedir}/lib/rpm-state/nvidia-container-toolkit/nvidia-container-runtime-hook %{_bindir}
fi
rm -rf %{_localstatedir}/lib/rpm-state/nvidia-container-toolkit
ln -sf %{_bindir}/nvidia-container-runtime-hook %{_bindir}/nvidia-container-toolkit

%postun
if [ "$1" = 0 ]; then
  if [ -L %{_bindir}/nvidia-container-toolkit ]; then rm -f %{_bindir}/nvidia-container-toolkit; fi
fi

%files base
%license LICENSE
%{_bindir}/nvidia-container-runtime
%{_bindir}/nvidia-ctk
%{_bindir}/nvidia-cdi-hook

%files
%license LICENSE
%{_bindir}/nvidia-container-runtime-hook

%files operator-extensions
%license LICENSE
%{_bindir}/nvidia-container-runtime.cdi
%{_bindir}/nvidia-container-runtime.legacy

%changelog
* Tue Jun 10 2025 zjl02254423 <zjl02254423@alibaba-inc.com> - 1.17.3-1
- Update vesion to fix CVE-2024-0135 CVE-2024-0136

* Tue Oct 08 2024 Chunmei Xu <xuchunmei@linux.alibaba.com> - 1.16.2-1
- update to 1.16.2

* Thu Jun  1 2023 forrest_ly <flin@linux.alibaba.com> - 1.13.1-1
- Add nvidia-container-toolkit to Anolis 23 
